// Lee Spector, lspector@hampshire.edu

// For this to work you must download the jm-etude package from: http://jmetude.dihardja.de/
// Put the extracted folder in your sketchbook's "libraries" (i.e. ~/Documents/Processing/libraries).

// See JMusic documentation at http://jmusic.cs.arizona.edu/doc/ for defined constants, etc.

import jmetude.*;

Etude e;
float[][] part1_notes = new float[16][2];
float[][] part2_notes = new float[16][2];
float[][] part3_notes = new float[16][2];
float[][] part4_notes = new float[16][2];


void fill_random (float[][] music) {
  for (int i = 0; i < 16; i = i + 1) {
    music[i][0] = int(random(e.C2, e.C7));
    music[i][1] = random(0.125, 4.0);
  }
} 


void setup() {
    size(200,100);
    e = new Etude(this);
    e.createScore("score");
    e.createPart("piano", e.PIANO, 1);
    e.createPart("bell", e.TUBULAR_BELL, 2);
    e.createPart("drum", e.TAIKO, 3);
    e.createPart("tuba", e.TUBA, 4);

    fill_random(part1_notes);
    fill_random(part2_notes);
    fill_random(part3_notes);
    fill_random(part4_notes);
    
    e.createPhrase("phrase1", part1_notes);
    e.createPhrase("phrase2", part2_notes);
    e.createPhrase("phrase3", part3_notes);
    e.createPhrase("phrase4", part4_notes);
    e.addPartPhrase("piano", "phrase1");
    e.addPartPhrase("bell", "phrase2");
    e.addPartPhrase("drum", "phrase3");
    e.addPartPhrase("tuba", "phrase4");
    e.addScorePart("score", "piano");
    e.addScorePart("score", "bell");
    e.addScorePart("score", "drum");
    e.addScorePart("score", "tuba");
    noLoop();
}

void draw() {
  e.stopMIDI();
  e.playMIDI("score");
}

