import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class turtle extends PApplet {// turtle.pde
// Simple Logo-style turtle graphics in Processing, with fractal examples
// Lee Spector (lspector@hampshire.edu), 2006
// Derived code by Tom Fuerstner, but little of Tom's code remains.

// The code in this file is in split into three sections:
// 1. Variables and procedures that implement simple turtle graphics commands
//    (forward, back, right, left, penup, pendown, setxy, setpc).
// 2. Higher-level procedures to draw fractal ferns, etc. 
//    (Add your own higher-level procedures to this section.)
// 3. Top level procedures "setup" (which defines the window size, the initial
//    turtle placement, etc.) and "draw". Add your own calls to turtle graphics
//    commands and/or to your own higher-level procedures in this section. 

////////////////////////////////////////////////////////////////////////////////
// Variables and procedures that implement simple turtle graphics commands

float xcor; 
float ycor; 
float angle; 
boolean penStateUp; 

public void forward(float distance) { 
  float initial_xcor, initial_ycor; 
  initial_xcor = xcor; 
  initial_ycor = ycor; 
  xcor += distance*cos(radians(angle)); 
  ycor += distance*sin(radians(angle)); 
  if (penStateUp == false) { 
    line (initial_xcor, initial_ycor, xcor, ycor); 
  } 
} 

public void back(float distance) { 
  float initial_xcor, initial_ycor; 
  initial_xcor = xcor; 
  initial_ycor = ycor; 
  xcor -= distance*cos(radians(angle)); 
  ycor -= distance*sin(radians(angle)); 
  if (penStateUp == false) { 
    line (initial_xcor, initial_ycor, xcor, ycor); 
  } 
} 

public void right(float degree) { 
  angle += degree; 
  if (angle >= 360) { 
    angle -= 360; 
  } 
} 

public void left(float degree) { 
  angle -= degree; 
  if (angle <= 0) { 
    angle += 360; 
  } 
} 

public void penup() { 
  penStateUp = true; 
} 

public void pendown() { 
  penStateUp = false; 
} 

public void setxy(float x, float y) { 
  xcor = x; 
  ycor = y; 
} 

public void setpc(float r, float g, float b) {
  stroke(r, g, b);
}

////////////////////////////////////////////////////////////////////////////////
// Higher-level procedures to draw fractal ferns, etc. 

public void tree(float distance) {
  if (distance < 5) {
  } 
  else {
    forward(distance);
    right(30);
    tree(distance * 0.75f);
    left(60);
    tree(distance * 0.75f);
    right(30);
    back(distance);
  }
}

public void fern(float size) {
  if (size < 5) {
  } else {
    forward(size/25);
    left(80);
    fern(size * 0.3f);  
    right(82);
    forward(size/25);
    right(80);
    fern(size * 0.3f);
    left(78);
    fern(size * 0.9f);
    left(2);
    back(size/25);
    left(2);
    back(size/25);
  }
}

public void bush(float sz, float level) {
  if (level< 1) {
  } else {
    setpc(random(255), random(255), random(255));
    forward(sz);
    right(75);
    bush(sz/1.5f, level - 1);
    left(90); 
    bush(sz/1.5f, level - 1);
    right(15);
    back(sz);
  }
}

////////////////////////////////////////////////////////////////////////////////
// Top level procedures

public void setup()  
{ 
  size(400, 400);            // set the window size
  background(255);           // set the background color
  setxy(width/2,height-50);  // move to near the bottom of the window
  angle = -90.0f;             // the turtle starts facing up
  penStateUp = true;         // the pen is initially up
  setpc(0,0,0);              // pen color is initially black
  noLoop();                  // execute the draw procedure only once
} 

public void draw()  
{ 
  pendown();
  
  //forward(50);
  //right (90);
  //forward(50);
  //right (90);
  //forward(50);
  //right (90);
  //forward(50);
  
  //tree(80);
  fern(500);
  //bush(100, 12);
 
}   
static public void main(String args[]) {   PApplet.main(new String[] { "turtle" });}}